// file : Box3d.cpp

#include "Box3d.h"

Box3d::Box3d(float minx, float maxx, float miny, float maxy, float minz, float maxz)
{
	min = Point3d( minx, miny, minz );
	max = Point3d( maxx, maxy, maxz );
}

Box3d::Box3d( Box3d& s )
{
	min=s.min;
	max=s.max;
}

Point3d Box3d::operator/ ( float d ) const
{
	return  (max+min) / d ;
}

Point3d Box3d::center() const
{
	return operator/ ( 2.0f );
}

Point3d operator/( Box3d const &s, Point3d const &d )
{
	return Point3d((s.max.x-s.min.x)/d.x,
		(s.max.y-s.min.y)/d.y,
		(s.max.z-s.min.z)/d.z);
		
}