// file : QuaternionOutputView.cpp

#include "QuaternionOutputView.h"
#include <be/interface/Screen.h>

QuaternionOutputView::QuaternionOutputView(BRect aRect) :
	BView( aRect, "Quaternionoutputview", B_FOLLOW_TOP | B_FOLLOW_LEFT, B_WILL_DRAW | B_PULSE_NEEDED )
{
	BRect aRect2(0,0, aRect.right - aRect.left, aRect.bottom - aRect.top );
	needsUpdate = false;
	theBitmap = new BBitmap( aRect2, B_CMAP8);
	theRenderer.setSize( aRect2.right + 1, aRect2.bottom + 1 );
	size = ( int )(( aRect2.right + 1 ) * ( aRect2.bottom + 1 ));
}

QuaternionOutputView::~QuaternionOutputView()
{
	delete theBitmap;
}

void QuaternionOutputView::render( QuaternionDescriptor *aDescriptor )
{
	BScreen screen; 
   	char buffer[size];
   	int i;

	// invoke the renderer
	theRenderer.setOutputBuffer( buffer );
	theRenderer.render( aDescriptor );	
	
	// convert the zbuffer to a black and white buffer
	for (i=0;i<size;i++)
		buffer[i] = screen.IndexForColor(buffer[i], buffer[i], buffer[i]);
	
	// update the bitmap
	theBitmap->SetBits(buffer, size, 0, B_CMAP8);
	needsUpdate = true;
}

void QuaternionOutputView::Draw(BRect updateRect)
{
	DrawBitmap( theBitmap ); //draw the bitmap
	needsUpdate = false;
}

void QuaternionOutputView::Pulse()
{
	if (needsUpdate) Draw(BRect(0,0,0,0)); //redraw anything...
}