// file : QuaternionRenderer.h

#ifndef quaternionrenderer_h_included
#define quaternionrenderer_h_included

#include "QuaternionDescriptor.h"
#include "Box3d.h"

const int zant=12;    //z-resolution. bigger zant -> better resolution
const int zant1=6;   //z-resolution. bigger zant -> better resolution

const Box3d bound(-1.0f, 1.0f, 
	-1.0f, 1.0f,
	-1.7f, 1.7f);
	  
const int iter=8;
const int maxcolor = 255;

class QuaternionRenderer
{
public:
	QuaternionRenderer();
	void render(QuaternionDescriptor *theDescriptor);
	void setSize( int newWidth, int newHeight );
	void setDescriptor(QuaternionDescriptor * aDescriptor);
	void setOutputBuffer( char* aBuffer );
private:
	void preRender();
	void render();
	void rotate3d( Point3d &v );
	void rotateValues();
	char trace2d( float px, float py );
	float trace3d( float x, float y, float z );
	
	QuaternionDescriptor *descriptorToCalculate;
	int height;
	int width;
	char* outputBuffer;
	
	Point3d d;//float dx,dy,dz;
	Point3d orig;
	Point3d rmin;//x, rminy, rminz;
	Point3d dx;// dxx, dxy, dxz;
	Point3d dy;// dyx, dyy, dyz;
	Point3d dz;//float dzx, dzy, dzz;
	Point3d dz1;//float dzx1, dzy1, dzz1;
	Point3d temp;// tempx, tempy, tempz;
	float cosx,cosy,cosz,sinx,siny,sinz;
	float dzf1;
};

#endif