// file : QuaternionSettingsWindow.h

#ifndef quaternionsettingswindow_h_included
#define quaternionsettingswindow_h_included

#include <be/interface/Window.h>
#include <be/interface/Slider.h>
#include <be/interface/Button.h>
#include <be/app/Application.h>
#include "QuaternionOutputWindow.h"

class QuaternionSettingsWindow : public BWindow
{
public:
	QuaternionSettingsWindow();
	virtual bool QuitRequested();
	BSlider* addSlider(char* labelName, int min, int max, char* minText, char* maxText);
	BButton* addButton(char* labelName, BMessage *theMessage);
	void MessageReceived(BMessage *theMessage);
	void setOutputWindow( QuaternionOutputWindow *source );
	void updateValueStrings();
private:	
	void render();
	void buildDescriptor();
	BSlider *sliderAlpha;
	BSlider *sliderBeta;
	BSlider *sliderGamma;
	BSlider *sliderCr;
	BSlider *sliderCi;
	BSlider *sliderCj;
	BSlider *sliderCk;
	BSlider *sliderWk;
	BButton *buttonQuit;
	BButton *buttonRender;
	BView *aView;
	QuaternionOutputWindow *theOutputWindow;
	int numberOfSlidersHooked;
	int numberOfButtonsHooked;
	QuaternionDescriptor theDescriptor;
};

#endif